shared="/build_shared/sweets"

[ -e /etc/resolv.conf ] || cp $shared/resolv.conf /etc/

api_url=$(cat $shared/api_url)
layers=$(cat $shared/layers)
repositories=$(cat $shared/repositories)
offline_activities=$(cat $shared/offline_activities)
favorite_activities=$(cat $shared/favorite_activities)
langs=$(cat $shared/langs)
locale=($(cat $shared/locale))
LANGUAGE="$(IFS=: ; echo "${locale[*]}")"

mkdir -p /etc/sweets.d
cat <<EOF >/etc/sweets.d/00-image.conf
# The following configuration populated during image creation
[client]
api-url = $api_url
layers = $layers
[packagekit-presolve]
repositories = $repositories
EOF

/etc/init.d/messagebus start
for i in $offline_activities; do
    echo " - Clone $i" >&2
    sudo -u olpc LANGUAGE="$LANGUAGE" sugar-network --quiet PUT /context/$i cmd=clone -jd true
done
/etc/init.d/messagebus stop

favorites=
default_favorites="/opt/sweets/sugar/share/sugar/data/activities.defaults"
rm -f $default_favorites
for i in $favorite_activities; do
    echo $i >> $default_favorites
    [ "$favorites" ] && favorites="$favorites,"
    favorites="$favorites\"$i\": {\"position\": [-1,-1]}"
done
mkdir -p /home/olpc/.sugar/default
cat <<EOF >/home/olpc/.sugar/default/favorite_activities
{
    "defaults-mtime": `date +%s`,
    "favorites": {$favorites}
}
EOF

rm -f /etc/locale.gen
for i in $langs; do
    echo $i >> /etc/locale.gen
done

cat >/home/olpc/.i18n.save <<EOF
LANG="${locale[0]}"
LANGUAGE="$LANGUAGE"
EOF

cat >/home/olpc/.xsession <<EOF
[ -e ~/.i18n.save ] && mv ~/.i18n{.save,}
exec sweets-sugar
EOF

fix_permissions="/etc/init.d/fix-permissions"
cat >$fix_permissions <<EOF
#!/bin/sh
# chkconfig: 345 99 99
case \$1 in
    start|restart)
        sudo -u olpc test -O /home/olpc/.gnome2 || chown olpc:olpc -R /home/olpc/.gnome2
        ;;
esac
EOF
chmod a+rx $fix_permissions
/sbin/chkconfig $(basename $fix_permissions) on
